// NEW GME related stuff
#ifndef GME2000COM_H
#define GME2000COM_H

#include "ComponentLib.h"


template <class TTT>
class COMArray {
public:
	CComPtr<TTT> *array;
	COMArray(long len)  { array = new CComPtr<TTT>[len]; };
	~COMArray() { delete[] array; };
};


#define COM_EQUAL(a, b) (static_cast<IUnknown *>(a) == b ? true : a.IsEqualObject(b))

#define MGACOLL_ITERATE(iftype, collifptr) \
{{{											\
ASSERT( collifptr != NULL );				\
long iter_count = 0;								\
COMTHROW( collifptr->get_Count(&iter_count) );		\
ASSERT( iter_count >= 0 );						\
COMArray<iftype> ca(iter_count); \
CComPtr<iftype> *arrptr, *arrend; \
if(iter_count > 0) { \
		unsigned long provided = 0; \
		if(iter_count > 0) COMTHROW( collifptr->GetAll((unsigned long)iter_count, &(*ca.array), &provided) ); \
		ASSERT( (unsigned long)iter_count == provided ); \
} \
arrend = ca.array+iter_count; \
for(arrptr = ca.array; arrptr != arrend; arrptr++)  
#define MGACOLL_ITER (*arrptr)
#define MGACOLL_AT_END (arrptr == arrend)

#define MGACOLL_ITERATE_END }}}

// these functions work together to implement exception handling
#define COMTRY try
#define COMTHROW(code) { HRESULT e = (code); \
						 if(e != S_OK) { COMVERIFY((##code, e)); throw e; } }
			
#define COMCATCH( cleanup)  catch(HRESULT hr) { cleanup; return hr;} return S_OK 

#endif // GME2000COM_H
