// warning.cpp : implementation file
//

//Local includes
#include "stdafx.h"
#include "warning.h"
#include "component.h"

//Global includes
#include <string>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Globals
user_preferences prefs;		//holds the users preferences	

bool WarningBox(CString msg)
{
	warning warning_box;
	return warning_box.display_message(msg);
}

void Load_User_Preferences()
{
	ifstream in;
	string word;
	int r;

	in.open("warning_prefs");

	//preferences for warnings file not found use defaults 
	if(in.fail())
	{
		Set_Default_Preferences();
		in.close();
		return;
	}

	//parse file
	while(!in.eof())
	{
		in >> word;

		if(in.eof())
			break;

		if(word == "DIFFERENT_CPUS_WARNINGS_ON")
		{
			r  = Get_True_False(in);

			if(r == -1)
				return;

			prefs.different_cpus_warnings_on = r;
		}
		else if(word == "NO_CPU_WARNINGS_ON")
		{
			r  = Get_True_False(in);

			if(r == -1)
				return;

			prefs.no_cpu_warnings_on = r;
		}
		else if(word == "ZERO_PERIOD_WARNINGS_ON")
		{
			r  = Get_True_False(in);

			if(r == -1)
				return;

			prefs.zero_period_warnings_on = r;
		}
		else if(word == "UNDEFINED_MEM_VARS_WARNINGS_ON")
		{
			r  = Get_True_False(in);

//			if(r)
//				AfxMessageBox("Loading undefined mem variables warning. - ON"); 
//			else
//				AfxMessageBox("Loading undefined mem variables warning. - OFF");

			if(r == -1)
				return;

			prefs.zero_period_warnings_on = r;
		}
		else
		{
			Read_Error(word.c_str());
			in.close();
			return;
		}
	}

	in.close();
}

int Get_True_False(ifstream& in)
{
	string word;

	in >> word;

	if(word == "TRUE")
		return 1;
	else if(word == "FALSE")
		return 0;
	else
	{
		Read_Error(word.c_str());
		in.close();
		return -1;
	}
}

void Read_Error(CString word)
{
	//set defaults
	Set_Default_Preferences();
			
	AfxMessageBox("Unknown word: " + word + " read in preferences/warnings file.  Setting preferences to defaults."); 
}

void Save_User_Preferences()
{
	ofstream out;

	out.open("warning_prefs");

	out << "DIFFERENT_CPUS_WARNINGS_ON";
	if(prefs.different_cpus_warnings_on)
		out << " TRUE\n";
	else
		out << " FALSE\n";



	out << "NO_CPU_WARNINGS_ON";
	if(prefs.no_cpu_warnings_on)
		out << " TRUE\n";
	else
		out << " FALSE\n";


	out << "ZERO_PERIOD_WARNINGS_ON";
	if(prefs.zero_period_warnings_on)
		out << " TRUE\n";
	else
		out << " FALSE\n";

	out << "UNDEFINED_MEM_VARS_WARNINGS_ON";
	if(prefs.undefined_mem_vars_warnings_on)
		out << " TRUE\n";
	else
		out << " FALSE\n";

	out.close();
}

void Set_Default_Preferences()
{
	prefs.different_cpus_warnings_on		= true;
	prefs.no_cpu_warnings_on				= true;
	prefs.zero_period_warnings_on			= true;
	prefs.undefined_mem_vars_warnings_on	= true;
}

/////////////////////////////////////////////////////////////////////////////
// warning dialog


warning::warning(CWnd* pParent /*=NULL*/)
	: CDialog(warning::IDD, pParent)
{
	//{{AFX_DATA_INIT(warning)
	//}}AFX_DATA_INIT

	checked = false;
}


void warning::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(warning)
	DDX_Control(pDX, IDC_EDIT1, m_edit);
	//}}AFX_DATA_MAP

	m_edit.SetWindowText(msg_str);
}


BEGIN_MESSAGE_MAP(warning, CDialog)
	//{{AFX_MSG_MAP(warning)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// warning message handlers

void warning::OnCheck() 
{
	checked = !checked;
}

bool warning::display_message(CString msg)
{
	msg_str = msg;
	this->DoModal();

	bool rval = checked;
	checked = false;

	return rval;
}
