#ifndef PRIORITY_ASSIGN_H
#define PRIORITY_ASSIGN_H

#include "system.h"
#include "graph.h"
#include "task_allocation.h"

typedef struct
{
    float initial_temperature;
    float temp_const;
    int equillibrium_jumps;
    int equillibrium_interval;
    float min_deadline_constant;
    float distinct_level_constant;
    float thread_comm_constant;
    int stopping_jumps;
    bool solution;
} SA_parameters;

typedef struct
{
    int num_jumps;
    int lower_energy_jumps;
    int higher_energy_jumps;
} SA_statistics;

extern void SA_priority_assign (Processor *, SA_parameters&);

#endif
