#ifndef TABLE_H_0
#define TABLE_H_0

using namespace std;

template<class T, class N> class Table
{
    struct table_internal
    {
        T node;
        int index;
    };
    private:
        int count;
        int limit;
        list<struct table_internal> index_mapping;
        N* array;

        int get_index(T t)
        {
            list<struct table_internal>::iterator it;

            for(it=index_mapping.begin();it!=index_mapping.end();it++)
            {
                struct table_internal ti=*it;

                if(ti.node==t) return ti.index;
            }
            return -1;
        }
    public:
        Table(){array=NULL;count=0;limit=0;}
        void Clear()
        {
            if(array) delete array;
            count=limit=0;
            index_mapping.clear();
        }
        void Set_Number_Of_Elements(int n)
        {
            if(array) delete array;
            array=new N[n*n];
            index_mapping.clear();
            count=0;
            limit=n;
        }
        inline int Get_Number_Of_Elements(){return limit;}
        void Initialize(N n)
        {
            int i;

            for(i=0;i<limit*limit;i++) array[i]=n;
            return;
        }
        void Add_Element(T t)
        {
            if(count>=limit) return;
            struct table_internal tmp;

            tmp.node=t;
            tmp.index=count;
            count++;
            index_mapping.push_front(tmp);
        }
        void Set_Value(T t1, T t2, N n)
        {
            int i1=get_index(t1);
            int i2=get_index(t2);

            if(limit==0) return;
            if(i1<0||i2<0) return;
            int i=i1*limit+i2;
            if(i>limit*limit-1) return;
            array[i]=n;
            return;
        }
        int Get_Value(T t1, T t2, N& n)
        {
            int i1=get_index(t1);
            int i2=get_index(t2);

            if(limit==0) return 0;
            if(i1<0||i2<0) return 0;
            int i=i1*limit+i2;
            if(i>limit*limit-1) return 0;
            n=array[i];
            return 1;
        }
};
            
#endif
